% detection of AF and AFL
function [AFpct,AF,number,lev1,lev2,up,n,AmpP,Y] = func_PanalysisTodor(Y,SR,VB)
flDraw = 0;

% Initialization of parameters, which have to be returned by the function
n = 0;
%------------------------------------------------------------------------
Te=[0  0.0377  0.0566  0.0778  0.1223  0.1434  0.1624  0.2000  0.1624  0.1434  0.1223  0.0778  0.0566  0.0377  0];
qrs=VB; w=1;
T=1/SR;		% [s]
Yorg = Y; 
AF=0; number=0;
lev1=0; lev2=0; up=0;
AmpP = 0; AFpct = 0; k=1; j=1;

Yf(1:length(Y))=1;

% QT elimination
if(length(VB)>1)
    RRmean = median(VB(2:length(VB)) - VB(1:length(VB)-1));
    RRmax = max(VB(2:length(VB)) - VB(1:length(VB)-1));
    
    before=round(0.05*SR); % 50 ms (half of the QRS duration, suppose that the QRS is detected in the peak).........PR(Q) interval is between 120 and 200 ms, therefore Pend-Q interval is between 70 and 100 ms
    after=round(0.45*SR*sqrt(RRmean/SR)); % up to 0.43 sec (must be corrected for heart rate)
    durration = before + after + 2; 
    
    if(qrs(1) <= before)
        Beg = 2; 
    else 
        Beg = qrs(1) - before;
    end;
    
        xEnd = qrs(1) + after;
        Ydlt = (Y(Beg) - Y(xEnd)) / durration;
        Ycurrent = Y(Beg);
    for j= Beg:xEnd;
       Ycurrent = Ycurrent -  Ydlt;
       Y(j) = Ycurrent; 
       Yf(j) = 0;
    end;
        
    for k=2:length(qrs)-1;
        Beg = max((qrs(k) - before), 1);
        xEnd = min((qrs(k) + after), qrs(end));
        Ydlt = (Y(Beg) - Y(xEnd)) / durration;
        Ycurrent = Y(Beg);
        for j= Beg:xEnd;
           Ycurrent = Ycurrent -  Ydlt;
           Y(j) = Ycurrent; 
           Yf(j) = 0; 
        end;
        
        Beg = qrs(k) - before;
    end;
      
   Y(max((qrs(end)-before),1):qrs(end))=0;
end

% [b,a]=butter(2,[0.1 8]/(SR/2),'bandpass');
% Y = filter(b,a,Y);
%detecting P waves 


%[AF] = func_FFT_Todor(Y,Yf,VB);
AFpct = func_AF_Detector_VB_Todor(VB);

Ys(1:length(Y)) = 0;
Yd(1:length(Y)) = 0;
Ympt(1:length(Y))=0;

Yt(1:length(Y)) = 0;
YTe(1:length(Y)) = 0;
Yp(1:length(Y)) = 0;
Ydbg(1:length(Y)) = 0;

for i=3:length(Y)-3;
    Yd(i) = (Y(i) - Y(i+2)) + (Y(i) - Y(i-2));
    Yd(i) = Yd(i)* Yf(i);
    if Yd(i) < 0
            Yd(i) = 0; 
    end;
end;    

Temp = (sum(Yd)*3)/ length(Yd);

for i=1:length(Y)
    if Yd(i) < Temp
       Yd(i) = 0;  
    end;
end;    

for i=3:length(Y)-5;
    Ys(i) = Yd(i)+ Yd(i+1)+ Yd(i+2)+ Yd(i+3)+ Yd(i+4);
    Ys(i) = Ys(i)* Yf(i);
    Ys(i) = abs(Ys(i));
end;    
 
%template Process
for i=10:length(Y)-10;
    SumLeft  = Y(i-7)*Te(1)+ Y(i-6)*Te(2)+ Y(i-5)*Te(3)+ Y(i-4)*Te(4)+ Y(i-3)*Te(5)+ Y(i-2)*Te(6)+ Y(i-1)*Te(7)+ Y(i)*Te(8);
    SumRight = Y(i+1)*Te(9)+ Y(i+2)*Te(10)+ Y(i+3)*Te(11)+ Y(i+4)*Te(12)+ Y(i+5)*Te(13)+ Y(i+6)*Te(14) + Y(i+7)*Te(15);
    
    if(Y(i) > 0)
        YTe(i) = SumLeft + SumRight;
    end
    
end;    

  Ycurrent = 0; 
  Trsh = sum(Ys)/ length(Ys);
  Low  = Trsh*2;
  Ycurr = Trsh*8; 
  OldMax = Trsh*8; 
  delta = Trsh / 60; 
  flgEmptyRR = 1; 
  k=0;w=1; 
  jump =0;
   
   %Main loop 
   for i=20:length(Ys) - 50;
       
      % Ydbg(i) = Ycurr; % for debug must removed  
       Ympt(w) = Yorg(i)*Yf(i);
       w=w+1;
       
       if (Yf(i-1) > 0 && Yf(i) == 0 &&  i > qrs(2))
          
       if(flgEmptyRR == 1)
             flgEmptyRR = 1;   
             Yt(i-w:i) = Ys(i-w:i);
             Ymean = mean(Ympt(1:w));
             if(Ymean < 0)
                 Ymean = (Ymean + min(Ympt(1:w))) / 2;
             end;
         
             for j=w:-1:5;  
                if (Ympt(j) - Ympt(j-4)) > 0.01 && (Ympt(j) - Ympt(j+4)) > 0.01 && Ympt(j) > Ymean
                    k=k+1;
                    n(k) = i-(w-j);
                    Yp(i-(w-j)) = 550;
                    flgEmptyRR = 0; 
                    break;
                 end ;  
             end; 
         
            if(j==5) 
             for j=w:-1:5;  
                if Ympt(j) < Ympt(j-4) && Ympt(j) < Ympt(j+4) && Ympt(j) < Ymean
                    k=k+1;
                    n(k) = i-(w-j);
                    Yp(i-(w-j)) = 550;
                    flgEmptyRR = 0; 
                    break;
                 end ;  
             end; 
            end;
       end;  
       
       Ympt(1:w+2)=0;
       w=1;    
       flgEmptyRR = 1;  
       end;
                
       if(jump > 0)
        jump = jump - 1;    
        continue;   
       end;
       
       if(Ycurr > Low)
        Ycurr = Ycurr - delta; 
       end; 
                     
       if (Ys(i) > Ycurr);
         jump = 10;  
         Ymax = max(Ys(i:i+20));
         
             [M,I] = max(Yorg(i:i+15));
             k=k+1;  
                                         
             for j=(i-5):(i+15)  
                    if (Yorg(j) - Yorg(j-4)) > 0.02 && (Yorg(j) - Yorg(j+4)) > 0.02 &&  Yf(j) > 0 
                     n(k) = j;
                     Yp(j) = 150;
                     flgEmptyRR = 0; 
                     break;
                  end ;  
             end;    
             
             if(j == i+15)
                n(k) = i; 
                Yp(i) = 400;
                flgEmptyRR = 0; 
             end;   
            
             if(Ymax > OldMax*2)
               Ycurr = OldMax*2;  
               delta = Ycurr / 40; 
             else
               Ycurr =  Ymax; 
               delta = Ycurr /80; 
             end;
             
             OldMax = Ycurr;
       end;
   end;

   jump =0; 
  
   
   
   for i=0:(k-3)
      delta = n(k-i) - n(k-i-1); 
      if(delta < 15)
          n(k-i-1) = [];
         continue; 
      end;
      
       PosN = n(k-i);
       if(YTe(PosN) == 0  && 0)
           n(k-i) = [];
       end;
   end;

   
if (AFpct < 50)   
   
    for i=0:length(VB) - 2

    end_period = VB(end - i); 
    beg_period = VB(end - (i+1));
    flgNDetect = 0; 
           
        for j=1:length(n) - 2

          if(n(end - j) >  beg_period && n(end - j) <  end_period && flgNDetect == 0)
             flgNDetect = 1; 
             continue;
          end;

         if(n(end - j) >  beg_period && n(end - j) <  end_period && flgNDetect > 0)
            n(end - j) = length(Yf);   
            continue;
         end;

       end;
   end;
   
end;
   
     
   
% delete 'C:\\Array.txt';   
% Yx = round(Y*1000);   
% fileID = fopen('C:\\Array.txt','w');
%  for i=1:length(Yx);
%     fprintf(fileID,'%d\n',Yx(i));  
%  end
% fclose(fileID);
%    
% delete 'C:\\ArrayOrg.txt';   
% Yx = round(Yorg*1000);   
% fileID = fopen('C:\\ArrayOrg.txt','w');
%  for i=1:length(Yx);
%     fprintf(fileID,'%d\n',Yx(i));  
%  end
% fclose(fileID);
% 


jump =0; 

%!!!!!!!!!!!!!!!!!! IRENA !!!!!!!!!!!!!!!!!!!
AmpP = Y(n);
%!!!!!!!!!!!!!!!!!! IRENA !!!!!!!!!!!!!!!!!!!

end


% 
% x=T:T:length(Y)*T;
% mag=1; shi=-4;







function AFpct = func_AF_Detector_VB_Todor(VB)
RR(1:length(VB)) = 0;
RR = (VB(2:length(VB)) - VB(1:length(VB)-1));
[am,mx]=max(RR);
RR(mx) = [];
[am,mx]=max(RR);
RR(mx) = [];
[am,mx]=min(RR);
RR(mx) = [];
[am,mx]=min(RR);
RR(mx) = [];

RRmedian = round(median(RR));
RRmin = min(RR);
RRmax = max(RR);
RRmean = round(mean(RR));

 AFpct = 40;

if((RRmax -RRmean) > 25)
    AFpct = 80;
    return;
end

if((RRmax -RRmean) > 20)
    AFpct = 60;
    return;
end

if((RRmax -RRmean) < 10)
    AFpct = 0;
    return;
end

% delete 'C:\\Array.txt';   
%  fileID = fopen('C:\\ArrayRRA.txt','a+');
%      fprintf(fileID,'%d \t %d \t %d \t %d \t %d \t %d\n',RRmax,RRmean,RRmedian,RRmin,RRmax - RRmean,RRmax - RRmedian);  
%  fclose(fileID);

end



























% 
% 
% 
%  
% Temp = sum(abs(Yd))/ length(Yd);
% 
% for i=1:length(Yd);
%     if Yd(i) > Temp;
%       Yd(i) = Temp;  
%     end; 
%     
%     if Yd(i) < -Temp;
%       Yd(i) = -Temp;  
%     end; 
% end;    
% 
% Yd = abs(Yd);
% 
% Yp(1) = 0; Yp(5) = 0; Yp(2) = 0; Yp(3) = 0; Yp(4) = 0; 
% 
% for i=6:length(Yd)-6
%  
%     if (Yd(i) < Yd(i+1) && Yd(i) < Yd(i-1) && Yd(i) < Yd(i+2) && Yd(i) <
%     Yd(i-2) && Yd(i) < 9.003);
%      Yp(i) = 100;
%     else
%      Yp(i) = 0;
%     end
% end;
% 
% Yp(i+1) = 0; Yp(i+5) = 0; Yp(i+2) = 0; Yp(i+3) = 0; Yp(i+4) = 0; 
% 
% 
% for i=1:length(Yp)
%     Yp(i) = Yp(i)*Yf(i); 
% end;    
% 
% for i=1:length(Yp)
%     if(Yp(i) > 0);
%         
%     end;
% end;    
% 
% 
% 
% 
% 
% for k=2:length(qrs)-1;
%     xBeg = qrs(k-1) + after; xEnd = qrs(k); Ya = Yorg(xBeg:xEnd); Ma =
%     Yp(xBeg:xEnd); 
%     
%     for j=1:length(Ma);
%         if(Ma(length(Ma) - j +1) == 0)
%                  Ya(length(Ma) - j +1) = 0;
%         else
%             j = length(Ma) - j +1; 
%                 for p=j:length(Ya);
%                     Ya(p) = Ya(j);
%                 end;   
%             break;
%         end; 
%     end;
%     
%     for j=1:length(Ma);
%         if(Ma(j) == 0)
%              Ya(j) = 0;
%         else
%             for p=1:j;
%                     Ya(p) = Ya(j+1);
%             end; break;
%         end; 
%     end;
%            
%     
%     NmbPeaks = 0; for j=1:length(Ma);
%         if(Ma(j) > 0)
%            NmbPeaks = NmbPeaks + 1;  
%         end;
%     end; 
%     
%     
%     
%     
%     xEnd = 0; 
%     
% end;
% 
% 
% 
% 
% 
% 
% 
% 
%    
% YBegm = sum(Yb)/ length(Yb); YEndm = sum(Ye)/ length(Ye); Ymax = 0; YEmax
% = 0; 
%  for i=1:length(Yb); 
%  
%  if Yb(i) >  YBegm
%     if Ymax == 0 
%         Ymax = Yb(i); Yb(i)= 1000;
%     else
%       if Yb(i) >  Ymax
%         Ymax = Yb(i); Yb(i)= 1000; Yb(i-1) = 0; 
%       else
%          Yb(i) = 0;  
%       end;
%     end;
%      
%  else
%    Ymax = 0; Yb(i) = 0;   
%  end;    
%      %---------------------------------
%      
%  if Ye(i) >  YEndm
%     if YEmax == 0 
%         YEmax = Ye(i); Ye(i)= 1000;
%     else
%       if Ye(i) >  YEmax
%         YEmax = Ye(i); Ye(i)= 1000; Ye(i-1) = 0; 
%       else
%          Ye(i) = 0;  
%       end;
%     end;
%      
%  else
%    YEmax = 0; Ye(i) = 0;   
%  end;    
%           
%      
%  end;     
% 
% 
% 
%   
% 
% 
% AF=0; number=0; lev1=0; lev2=0; up=0; AmpP = 0; AFpct = 0; k=1; j=1;
% yx=Y;
% 
% return;
% 
% 
% for i=1:length(Y);
%         yx(i) = 0; 
% end
% 
% for i=11:length(Y)-11;
%     yx(i)= abs(Y(i)-Y(i-10)) + abs(Y(i)-Y(i+10)); if(yx(i) > 200)
%         yx(i) = 200;
%     end;         
% end;
% 
% YxMean = mean(yx); YxMax  =0; delta  = YxMean / 100; Low    = delta*10;
% jump =0;
% 
% 
% for i=1:length(Y)-100;
%     
%     bx(i) = YxMean; if(jump > 0)
%         jump = jump -1; continue;
%        end
%     
%     if( yx(i) >  YxMean) 
%         n(k) =i; YxMax = yx(i); for j=1:20;
%             if(yx(i+j) > YxMax)
%               YxMax =  yx(i+j); n(k) =i+ j;
%              end;
%         end; 
%         
%         if(YxMean * 2.5 > YxMax)
%            YxMean =  YxMax;
%         else
%            YxMean = YxMean * 2.5;
%         end; jump = 22; delta  = YxMean / 50; k=k+1; 
%     end;     
%     
%     if(YxMean > Low)
%         YxMean = YxMean  - delta;
%     end;